# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


struct SnapshotsApi <: SwaggerApi
    client::Swagger.Client
end

"""

Creates or updates a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Param: snapshot::Snapshot (required)
Return: Snapshot
"""
function snapshotsCreateOrUpdate(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String, snapshot; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", Snapshot, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}", ["azure_auth"], snapshot)
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Deletes a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Return: OperationStatusResponse
"""
function snapshotsDelete(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", OperationStatusResponse, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets information about a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Return: Snapshot
"""
function snapshotsGet(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Snapshot, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Grants access to a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Param: grantAccessData::GrantAccessData (required)
Return: AccessUri
"""
function snapshotsGrantAccess(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String, grantAccessData; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", AccessUri, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}/beginGetAccess", ["azure_auth"], grantAccessData)
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Lists snapshots under a subscription.
Param: subscriptionId::String (required)
Param: api_version::String (required)
Return: SnapshotList
"""
function snapshotsList(_api::SnapshotsApi, subscriptionId::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SnapshotList, "/subscriptions/{subscriptionId}/providers/Microsoft.Compute/snapshots", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Lists snapshots under a resource group.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: api_version::String (required)
Return: SnapshotList
"""
function snapshotsListByResourceGroup(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SnapshotList, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Revokes access to a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Return: OperationStatusResponse
"""
function snapshotsRevokeAccess(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", OperationStatusResponse, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}/endGetAccess", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Updates (patches) a snapshot.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: snapshotName::String (required)
Param: api_version::String (required)
Param: snapshot::SnapshotUpdate (required)
Return: Snapshot
"""
function snapshotsUpdate(_api::SnapshotsApi, subscriptionId::String, resourceGroupName::String, snapshotName::String, api_version::String, snapshot; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PATCH", Snapshot, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/snapshots/{snapshotName}", ["azure_auth"], snapshot)
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "snapshotName", snapshotName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export snapshotsCreateOrUpdate, snapshotsDelete, snapshotsGet, snapshotsGrantAccess, snapshotsList, snapshotsListByResourceGroup, snapshotsRevokeAccess, snapshotsUpdate
