# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


struct LocalNetworkGatewaysApi <: SwaggerApi
    client::Swagger.Client
end

"""

Creates or updates a local network gateway in the specified resource group.
Param: resourceGroupName::String (required)
Param: localNetworkGatewayName::String (required)
Param: parameters::LocalNetworkGateway (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: LocalNetworkGateway
"""
function localNetworkGatewaysCreateOrUpdate(_api::LocalNetworkGatewaysApi, resourceGroupName::String, localNetworkGatewayName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    Swagger.validate_param("localNetworkGatewayName", "localNetworkGatewaysCreateOrUpdate", :minLength, localNetworkGatewayName, 1)

    _ctx = Swagger.Ctx(_api.client, "PUT", LocalNetworkGateway, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "localNetworkGatewayName", localNetworkGatewayName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Deletes the specified local network gateway.
Param: resourceGroupName::String (required)
Param: localNetworkGatewayName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: Nothing
"""
function localNetworkGatewaysDelete(_api::LocalNetworkGatewaysApi, resourceGroupName::String, localNetworkGatewayName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    Swagger.validate_param("localNetworkGatewayName", "localNetworkGatewaysDelete", :minLength, localNetworkGatewayName, 1)

    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "localNetworkGatewayName", localNetworkGatewayName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets the specified local network gateway in a resource group.
Param: resourceGroupName::String (required)
Param: localNetworkGatewayName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: LocalNetworkGateway
"""
function localNetworkGatewaysGet(_api::LocalNetworkGatewaysApi, resourceGroupName::String, localNetworkGatewayName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    Swagger.validate_param("localNetworkGatewayName", "localNetworkGatewaysGet", :minLength, localNetworkGatewayName, 1)

    _ctx = Swagger.Ctx(_api.client, "GET", LocalNetworkGateway, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways/{localNetworkGatewayName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "localNetworkGatewayName", localNetworkGatewayName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets all the local network gateways in a resource group.
Param: resourceGroupName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: LocalNetworkGatewayListResult
"""
function localNetworkGatewaysList(_api::LocalNetworkGatewaysApi, resourceGroupName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", LocalNetworkGatewayListResult, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/localNetworkGateways", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export localNetworkGatewaysCreateOrUpdate, localNetworkGatewaysDelete, localNetworkGatewaysGet, localNetworkGatewaysList
