# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


struct PolicyDefinitionsApi <: SwaggerApi
    client::Swagger.Client
end

"""

Creates or updates a policy definition.
Param: policyDefinitionName::String (required)
Param: parameters::PolicyDefinition (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsCreateOrUpdate(_api::PolicyDefinitionsApi, policyDefinitionName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", PolicyDefinition, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policydefinitions/{policyDefinitionName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Deletes a policy definition.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: Nothing
"""
function policyDefinitionsDelete(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policydefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets the policy definition.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsGet(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinition, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policydefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets all the policy definitions for a subscription.
Param: api_version::String (required)
Param: subscriptionId::String (required)
Param: filter::String
Return: PolicyDefinitionListResult
"""
function policyDefinitionsList(_api::PolicyDefinitionsApi, api_version::String, subscriptionId::String; filter=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinitionListResult, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policydefinitions", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "\$filter", filter)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json", "text/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", "text/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export policyDefinitionsCreateOrUpdate, policyDefinitionsDelete, policyDefinitionsGet, policyDefinitionsList
