# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


struct SubscriptionsApi <: SwaggerApi
    client::Swagger.Client
end

"""

Gets details about a specified subscription.
Param: subscriptionId::String (required)
Param: api_version::String (required)
Return: Subscription
"""
function subscriptionsGet(_api::SubscriptionsApi, subscriptionId::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", Subscription, "/subscriptions/{subscriptionId}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Gets all subscriptions for a tenant.
Param: api_version::String (required)
Return: SubscriptionListResult
"""
function subscriptionsList(_api::SubscriptionsApi, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SubscriptionListResult, "/subscriptions", ["azure_auth"])
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Gets all available geo-locations.
This operation provides all the locations that are available for resource providers; however, each resource provider may support a subset of this list.
Param: subscriptionId::String (required)
Param: api_version::String (required)
Return: LocationListResult
"""
function subscriptionsListLocations(_api::SubscriptionsApi, subscriptionId::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", LocationListResult, "/subscriptions/{subscriptionId}/locations", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export subscriptionsGet, subscriptionsList, subscriptionsListLocations
